\section{CI/CD Services}
% services offerts par les frontends

\subsection{FrontEnd}


\begin{frame}[label={sec:front}]{FrontEnd}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{CI native web Front End}

CI Web Front End can be grouped in 2 major categories:
    \begin{columns}[onlytextwidth,T]
      \column{0.4\dimexpr\linewidth}
            \begin{itemize}
                \item Dedicated UI
                \item Integrated to the code forge 
            \end{itemize}

        \column{0.6\dimexpr\linewidth}
        
            %\includegraphics[scale=0.1]{jenkins/images/one_project_pipeline.png}
         	\includegraphics[scale=0.1]{gitlab/images/one_project_pipeline_smaller.png}
         	\includegraphics[scale=0.08]{github/images/all_workflow_screenshot.png}
     	
    \end{columns}
\end{block}

\begin{block}{CI alternative Front End}
      Some environment may provide some alternative Front End in order to integrate within the user's workspace.

    \begin{columns}[onlytextwidth,T]
      \column{\dimexpr\linewidth-40mm-5mm}
For example, IDE integration

or even command line / terminal integration
        \column{40mm}
        %\begin{flushright}
     	\includegraphics[width=30mm]{gitlab/images/vscode_pipeline_view_fil-rouge.png}
     	%\end{flushright}

    \end{columns}
\end{block}


\begin{block}{TODO}
TODO add jenkins and github small screenshots
\end{block}




%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:front-end-comparison}]{Compared Front End}
%------------------------------------------ diapo -----------------------------------------------

\begin{center}
\rowcolors{2}{JungleGreen}{BlueGreen}
\begin{tabular}{ | m{7em} ||m{0.22\columnwidth}|m{0.22\columnwidth}|m{0.22\columnwidth}| } 

\hline
\rowcolor{lightgray}
 & Jenkins & Gitlab CI & Github Action  
\\
\hhline{|=||=|=|=|}
Native Web Front end &
    Dedicated UI &
    Integrated to the code forge &
    Integrated to the code forge 
\\ 
\hline
IDE integration & 
    
    VSCode \footnote[frame]{\tiny{\url{https://marketplace.visualstudio.com/items?itemName=alefragnani.jenkins-status}}}
    Eclipse \footnote[frame]{\tiny{\url{https://marketplace.eclipse.org/content/hudsonjenkins-mylyn-builds-connector}}}
    IntelliJ \footnote[frame]{\tiny{\url{https://plugins.jetbrains.com/plugin/6110-jenkins-control}}}&
    
    VSCode \footnote[frame]{\tiny{\url{https://docs.gitlab.com/ee/user/project/repository/vscode.html}}} &  
    
    VSCode \footnote[frame]{\tiny{\url{https://marketplace.visualstudio.com/items?itemName=cschleiden.vscode-github-actions}}} 
\\ 
\hline

Command line integration & 
    ? &
    Yes \footnote[frame]{\tiny{\url{https://gitlab.com/gitlab-org/cli}}}&  
    ?
    
\\ 
\hline
\end{tabular}
\end{center}


%------------------------------------------------------------------------------------------------
\end{frame}

\ifthenelse{\boolean{includeSpecificSlides}}{
		\begin{frame}[label={sec:front-in-practice}]{FrontEnd in practice}
%------------------------------------------ diapo -----------------------------------------------
		\begin{block}{FrontEnd in practice}
			TODO include specific slides
		\end{block}
%------------------------------------------------------------------------------------------------
		\end{frame}
		% TODO input specific slides 
	}
	{}%else

\includeGitlab{20-cicd-services-frontend}


\subsection{Job management 1/2}

\begin{frame}[fragile,label={sec:services-job-managment-1}]{Job management}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Logical view}
CI actions are usually organized in a DAG of Jobs (aka Pipeline): 
\begin{itemize}
\item Node are the actions
\item Edge are the dependency between the actions
\begin{itemize}
    \item control dependency ($job_i$ must run after $job_j$)
    \item data dependency ($job_i$'s output is required as input for $job_j$)
\end{itemize}
\end{itemize}
\end{block}

\begin{figure}[!h]
\begin{center}
\includegraphics[width=0.7\linewidth]{images/excalidraw/job-management-logical.png}
\end{center}
\caption{An imaginary pipeline -- logical view}
\end{figure}

%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[fragile, label={sec:services-job-managment-2}]{Job management 2/2}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Physical view}
Those jobs may have to run on different infrastructures.

\end{block}

\begin{figure}[!h]
\begin{center}
\includegraphics[width=0.7\linewidth]{images/excalidraw/job-management-physical.png}
\caption{An imaginary pipeline -- physical view}
\end{center}
\end{figure}

%------------------------------------------------------------------------------------------------
\end{frame}

\subsection{Runners}


\begin{frame}[label={sec:service-runners}]{Runners}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{What is a runner}
\begin{itemize}
\item A runner/slave is a compute resource where CI tasks may be executed
\item It may be a bare metal server or a virtual machine
\item CI tasks may be simple jobs, or complex pipelines 
\end{itemize}
\end{block}

\end{frame}

\begin{frame}{Runners@Inria}

What can they be:
\begin{itemize}
    \item Virtual Machines on CloudStack (e.g. originally used by Jenkins but can be used by Gitlab, or Github Action)
    \item Shared Runners on gitlab.inria.fr (docker based)
    \item Any machine (can be used by Jenkins, Gitlab, or Github Action)
    \item BareMetal machine on testbeds (Igrida / Grid'5000\footnote[frame]{not really fully automated process})
\end{itemize}

%différents type de runners
%détail des offres en fonction des instances

% TODO Présenter plutôt l'offre de services Inria 

%\begin{block}{Shared runner}
%Shared runner (ready use and offered by the CI platform)
%    gitlab-CI shared runners
%    githubaction VM

%\end{block}

%\begin{block}{}
%\begin{itemize}
%    \item User personnal computer (or server)
%    \item CloudStack Inria
%    \item Grid5000
%    \item Igrida
%\end{itemize}

%\end{block}
\end{frame}

\begin{frame}
\begin{block}{Gitlab}
\begin{itemize}
\item {\it GitLab Runner} is an application that works with GitLab to run jobs in a pipeline
\item Runners are processes that pick up (polling) and execute CI/CD jobs for GitLab
\end{itemize}
\end{block}

\begin{block}{Jenkins}
\begin{itemize}
\item xxx
\item xxx
\end{itemize}
\end{block}

\begin{block}{CDash}
\begin{itemize}
\item xxx
\item xxx
\end{itemize}
\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}


\subsection{SCM}



\begin{frame}[label={sec:services-vcs}]{Version Control Systems }
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{}
CI primary input is based on Version Control Systems
to obtain the source code that they'll build.


\end{block}

\begin{block}{Mono VCS CI}
Some CI are dedicated to one kind of VCS and can handle only one system

Example of CI dedicated to git only:
\begin{itemize}
    \item gitlab-CI
    \item github Action
\end{itemize}

Mono-VCS CI are natively driven by a single repository. Ie. the CI configuration scripts are dedicated for a single repository. The repository hosts the CI configuration script.

It is possible to build tasks that checkout sources from multiple repositories but this requires either writing some checkout scripts or using VCS submodule support
\end{block}

\begin{block}{Multi VCS CI}
Some CI can handle multiple kind of VCS.

The CI can handles sources from multiple repositories such as git, subversion, cvs, ...

Additionnaly the CI configuration allows to checkout sources from multiple repositories for a given job.

Example:
\begin{itemize}
    \item Jenkins
    \item CDash
\end{itemize}

\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}



\subsection{Triggering}

\begin{frame}[label={sec:services-triggering}]{Triggering}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Events that can trigger a job}
\begin{itemize}
    \item \textbf{Code pushes}: triggered every time code is pushed to a repository. 
     Useful for running automated tests or building and deploying code changes.

    \item \textbf{Pull request events}: triggered when a pull request is opened, updated, or merged. 
    Useful for running automated tests or code reviews as part of the pull request process.

    \item \textbf{Merge request events}: Similar to pull request events, triggered when a merge request is opened, updated, or merged in a forge.

    \item \textbf{Scheduled events}: triggered at a specific time or on a regular schedule. Useful for running periodic tasks such as backups or system maintenance.

    \item \textbf{External events}: triggered by an external event, such as a webhook or an API call. Useful for integrating with other systems or for triggering tasks manually.
\end{itemize}


\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}


\begin{frame}[label={sec:triggering-comparison}]{Compared Triggering}
%------------------------------------------ diapo -----------------------------------------------

\begin{center}
\rowcolors{2}{JungleGreen}{BlueGreen}
\begin{tabular}{ | m{7em} ||m{0.22\columnwidth}|m{0.22\columnwidth}|m{0.22\columnwidth}| } 

\hline
\rowcolor{lightgray}
 & Jenkins & Gitlab CI & Github Action  
\\
\hhline{|=||=|=|=|}
Code pushes &
    By pooling or immediately via a plugin dedicated to the forge \footnote[frame]{the plugins requires some configuration on the forge (token)} &
    Yes &
    Yes 
\\ 
\hline
Pull request & 
   TODO verify the plugin features for gitlab and github &
   Yes &  
   Yes  
\\ 
\hline
Merge request & 
    TODO verify the plugin features for gitlab and github &
    Yes &  
    Yes 
\\ 
\hline
Scheduled events & 
    Yes &
    Yes &  
    Yes
\\ 
\hline
External events & 
    Yes &
    Yes &  
    Yes 
\\ 
\hline
\end{tabular}
\end{center}

\begin{block}{TODO}
verify fine capacity in filtering event on branch, folder, 
\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}



\subsection{Notifications}

\begin{frame}[label={sec:services-notifications}]{Notifications}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Notifications}
The CICD can send notification to the user, typically to warn her about failed build.

It can be on the form of Email, instant messaging system or integration in the user workspace (IDE)

Depending on the system it may be configurable
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:notification-comparison}]{Compared Notification}
%------------------------------------------ diapo -----------------------------------------------

\begin{center}
\rowcolors{2}{JungleGreen}{BlueGreen}
\begin{tabular}{ | m{7em} ||m{0.22\columnwidth}|m{0.22\columnwidth}|m{0.22\columnwidth}| } 

\hline
\rowcolor{lightgray}
 & Jenkins & Gitlab CI & Github Action  
\\
\hhline{|=||=|=|=|}
Predefined &
    No\footnote[frame]{the plugins requires some configuration} &
    Yes via Email\footnote[frame]{no configuration required \label{notification-comparison-no-configuration-required}} &
    Yes via Email \textsuperscript{\ref{notification-comparison-no-configuration-required}} \footnote[frame]{depend on the notification preferences of the user on github}
\\ 
\hline
Customizable Email & 
   Yes &
   ? &  
   Via Action  \footnote[frame]{Requires a smtp server}
\\ 
\hline
Support for Mattermost & 
    ? &
    Yes via Integration system &  
    ? 
\\ 
\hline
Custom system& 
    Via plugin or via user script  &
    Via user script, Application integration system and webhook  &  
    Via action or user script
\\ 

\hline
\end{tabular}
\end{center}

\begin{block}{TODO}
verify existence of plugin system for gitlab, github ? 
\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}


\includeGitlab{20-cicd-notifications}
\includeGithub{20-cicd-notifications}


\subsection{CD}


\begin{frame}[label={sec:CDservice}]{CD}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{TODO}
deployment/delivery
update in a repository, in a web site, database migration, (hot)restart webserver, allgo
\end{block}

\end{frame}